

function getParameterByName(name, url) {
    if (!url) url = window.location.href;
    name = name.replace(/[\[\]]/g, "\\$&");
    var regex = new RegExp("[?&]" + name + "(=([^&#]*)|&|#|$)"),
        results = regex.exec(url);
    if (!results) return null;
    if (!results[2]) return '';
    return decodeURIComponent(results[2].replace(/\+/g, " "));
}

new Headroom(document.querySelector("header")).init();

var crrURL = window.location.href
if (typeof(Storage) !== "undefined" && crrURL.indexOf("goBack") == -1) {
    var localStorageURL = localStorage.getItem("lastURL")
    if(localStorageURL != null && localStorageURL != "") {
        var l = localStorageURL
        if (window.location != l) {
            window.location.href = l
            localStorage.setItem("lastURL", "")
        }
    }
}

var currentPath = getParameterByName('q', url)
currentPath = currentPath == null ? "" : currentPath + "/"
var ljson = "filelist.json"
var url = "https://static.soundcorset.com/score/" + currentPath + ljson
var qParemeter = "&q="
var enableHomeString = "?home=true"
var disableHomeString = "?home=false"
var linkHTML = "view.html"
var myScore = "My Score"
var firstPage = currentPath.length <= 0

function realHomeString() {
   return containHome() == true ? enableHomeString : disableHomeString
}

function containHome() {
    return (crrURL.indexOf(enableHomeString) != -1)
}

function linkHref(v) {
    var hString = realHomeString()
    return '<a href="'+linkHTML + hString + qParemeter + currentPath + v + '" data-ajax="false">'
}

function linkHrefRow(v) {
    var hString = realHomeString() 
    return '<a href="'+linkHTML + hString + qParemeter + currentPath + v + '" class="nextBtn" data-ajax="false">'
}

function upperLink(l) {
    var realLink = l.substring(0, l.length-1)
    return realLink.substring(0, realLink.lastIndexOf('/'))
}

function paths() {
    var fullPath = currentPath
    var folderPaths = []
    while(fullPath.length > 0) {
        fullPath = fullPath.substr(0, fullPath.lastIndexOf('/'))
        folderPaths.push(fullPath)
    }
    return folderPaths.reverse()
}

function urlExists(url) {
    var http = new XMLHttpRequest()
    http.open('HEAD', url, false)
    http.send()
    return http.status!=404
}

function Get(yourUrl){
    var Httpreq = new XMLHttpRequest()
    Httpreq.open("GET",yourUrl,false)
    Httpreq.send(null)
    return Httpreq.responseText
}

function checkImgURL(url){
    return(url.match(/\.(jpeg|jpg|gif|png)$/) != null);
}

var startTime
var startDate
var endTime
function loadView() {
    var staticPage = 'https://static.soundcorset.com/scoreView/chartscore.html'
    var menu = document.getElementById("menu")
    var menuStr = ''
    if(firstPage) {
        menu.innerHTML += '<div style="float:left;">'
                        + '<a href="'+linkHTML+realHomeString()+'?goBack" class="" data-ajax="false"><img class="Centered head" src="back.png"></a>'
                        + '</div>'
    } else {
        menuStr = '<div style="float:left;">'
        if(containHome()==true) {
            menuStr += '<a href="'+linkHTML+realHomeString()+'?goBack" class="" data-ajax="false"><img class="Centered head" src="metro.png"></a>'
        }
        menuStr += '<a href="'+linkHTML+realHomeString()+'?goHome" class="" data-ajax="false"><img class="Centered head" src="musicsheet.png"></a>'
                + '</div>'
        menu.innerHTML += menuStr
    }

    var fdPaths = paths()
    var l = fdPaths[fdPaths.length -1]
    var titleFolder = ''
    menuStr = '<div class="titleCenter" style="display: inline-block;">'
    if(firstPage) {
        titleFolder = 'Sheet Music'
        menuStr += '<img class="Centered titleCenter" src="music_icon.png">'
    } else {
        titleFolder = l.substr(l.lastIndexOf('/') + 1, l.length)
        l = (l.lastIndexOf('/') == -1) ? '?goHome' : qParemeter + l.substr(0, l.lastIndexOf('/'))
        menuStr += '<img class="Centered" src="back_row.png" style="width: 30px;">'
    }
    
    menuStr += '<a class="titleCenter" style="font-size: 20px; color: white" href="' + linkHTML + realHomeString() + l +'" data-ajax="false">' + titleFolder        
            + '</a>'
            + '</div>'
    menu.innerHTML += menuStr

    menu.innerHTML += '<div style="float:right;">'
                    + '<a href="' + staticPage +'" class="" data-ajax="false"> <img class="Centered tail" src="statistics.png" > </a>'
                    + '<a href="' + linkHTML + realHomeString() + '?goCamera" class="" data-ajax="false"><img class="Centered tail" src="camera.png"></a>'
                    + '</div>'

    if(currentPath.indexOf(myScore) != -1) {
        if(window.Android) {
            if(currentPath != myScore + '/') {
                var foName = crrURL.substring(crrURL.lastIndexOf('/') + 1).split("%20").join(' ');
                var j = JSON.parse(Android.getJson(foName))
                j.files.map(function(v, i) {
                    var l = v.name
                    if(checkImgURL(l)) {
                         var path = "file://" + l
                         document.getElementById("content").innerHTML += '<img class ="score" src="'+path+'" >'
                    }
                });
                menu.innerHTML += '<a href="'+linkHTML+realHomeString()+'?goEdit'+foName+'" class="menuBtn" data-ajax="false">Edit</a>'
                }
            else {
                console.log("this is the page")
                var output = '<table style="width:100%">'
                var files = JSON.parse(Android.getCameraFolders())
                files.map(function(v, i) {
                    var path = "file://" + v
                    var nF = v.substring(v.lastIndexOf('/') + 1)
                    var color = i % 2 != 0 ? 'bgcolor="white"' : 'bgcolor="#f1f1f1"'
                    output += '<tr '+color+'><td width = "100%">' + linkHref(nF) + nF +  '</a></td></tr>'
                });
                output += '</table>'
                document.getElementById("content").innerHTML += output
            } 
        }
    }
    else {
        var json_obj = JSON.parse(Get(url))
        var files = json_obj.files
        var value = []
        for (var i = 0; i < files.length; i++) {
            console.log("file" + files[i])
            value.push(files[i].name)
        }

        var output = ''
        if (value[0].indexOf("json") > -1) {            
            startTime = new Date()
            console.log("datttttteeeeeeeeee")
            for (i = 0; i < value.length; i++) {
                var n = value[i].replace("json", "png")
                var u = url.replace(ljson, n)
                output += '<img class="score" src="' + u + '"><br>'
            }
            document.getElementById("content").innerHTML += output
        }
        else {
            if(firstPage) {
                value.push(myScore)
                var htmlString = '<div class="container-fluid">'
                for (var i = 0;  i < value.length;  i++) {
                    htmlString += linkHref(value[i])
                    htmlString += '<div class="col-xs-3">'
                    htmlString += '<div class="grid text-container" align="center" style="word-wrap: break-word;" >' 
                    htmlString += '<font size="5.0" style="vertical-align: middle;"><u><b>' + value[i] + '</b></u></font>'
                    htmlString += '</div>'
                    htmlString += '</div></a>'
                }
                htmlString += '</div>'
                document.getElementById("content").innerHTML += htmlString
            }
            else {
                output += '<table class="subSong" cellpadding="4">'
                var prePage = 'https://static.soundcorset.com/score/' + currentPath + value[0] + '/preview.png'

                if(urlExists(prePage)) {
                    for (i = 0; i < value.length; i++) {
                        var u = url.replace(ljson, "") + value[i] + '/preview.png'
                        var color = i % 2 != 0 ? 'bgcolor="white"' : 'bgcolor="#f1f1f1"'
                        output += '<tr '+color+'><td width = "10%">' + linkHref(value[i]) + value[i] + '</a></td>'
                        output += '<td width = "90%">' + linkHref(value[i]) + '<img class ="score" src="' + u + '"> </a> </td></tr>'
                    }
                }
                else {
                    for (i = 0; i < value.length; i++) {
                        var color = 'bgcolor="#f5f2f2"'
                        output   += '<tr style = "height: 50px" ' + color
                        output   += '><td width = "90%" style="padding-left:10px">' +  linkHref(value[i]) + '<div> <font size="3.5"><u><b>' + value[i] + '</b></u></font></div>' + '</a></td>'
                    }
                }
                output += '</table>'
                document.getElementById("content").innerHTML += output
            }
        } 
    }
}

loadView();
// document.body.innerHTML += '<div class="loader"></div>'
// window.onload = function () {
//     $('.loader').remove()
// }

$(window).on('unload ',function() {
    console.log("start time " + startTime)
    var start = startTime.getTime()
    if (start != 0) {
        endTime = new Date()
        var startDate = startTime.toLocaleDateString()

        var timeInterval = endTime.getTime() - startTime.getTime()
        //timeInterval -= idleInterval

        var practices = JSON.parse(localStorage.getItem("practice"))
        if (practices == null) { practices = {} }
        var pDate = practices[startDate]
        if (pDate == null) { pDate = {} }
        if (pDate.hasOwnProperty(currentPath)) {
            pDate[currentPath] += timeInterval
        }
        else {
            pDate[currentPath] = timeInterval
        }
        practices[startDate] = pDate

        localStorage.setItem("practice", JSON.stringify(practices))

        //localStorage.setItem("touch", idleInterval)
    }
});

var practices = JSON.parse(localStorage.getItem("practice"))
var dateKeys = Object.keys(practices)
var today = new Date()
var oldestDate = new Date(dateKeys[0])
if ( today.getTime() - oldestDate.getTime() > 30 * 24 * 60 * 60 * 1000) {
   delete practices[dateKeys[0]]
}
localStorage.setItem("practice", JSON.stringify(practices))

var currPos = getParameterByName('p', crrURL)
$('body').animate({scrollTop:currPos},1000)
$('#goBack').click(function(){
    var scrolled_val = $(document).scrollTop().valueOf()
    var lastLink = window.location.href + '&p='+scrolled_val+''
    localStorage.setItem("lastURL", lastLink)
});
